#if !defined(AFX_CFGPROPSHEET_H__INCLUDED_)
#define AFX_CFGPROPSHEET_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CfgPropSheet.h : header file
//

#include "resource.h"
#include "Dlgbars.h"
#include "scommon.h"

/////////////////////////////////////////////////////////////////////////////
// CCfgPropPage 

class CCfgPropPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CCfgPropPage)

// Construction
public:
	CCfgPropPage();
	CCfgPropPage(UINT nIDTemplate, UINT nIDCaption = 0, UINT nIDHeaderTitle = 0, UINT nIDHeaderSubTitle = 0);
	CCfgPropPage(LPCTSTR lpszTemplateName, UINT nIDCaption = 0, UINT nIDHeaderTitle = 0, UINT nIDHeaderSubTitle = 0);
	
	~CCfgPropPage();

// Dialog Data
	//{{AFX_DATA(CCfgPropPage)
		// NOTE - ClassWizard will add data members here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CCfgPropPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CCfgPropPage)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	BOOL OnToolTipText(UINT, NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////
// CCfgPropSheet

class CCfgPropSheet : public CPropertySheet
{
	DECLARE_DYNAMIC(CCfgPropSheet)

// Construction
public:
	CCfgPropSheet(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0, HBITMAP hbmWatermark = NULL, HPALETTE hpalWatermark = NULL, HBITMAP hbmHeader = NULL );
	CCfgPropSheet(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0, HBITMAP hbmWatermark = NULL, HPALETTE hpalWatermark = NULL, HBITMAP hbmHeader = NULL );
	//TBSTYLE_CHECKGROUP |
	BOOL InitCfgPropSheet(BOOL bToolTips = FALSE, BOOL bStatusBar = FALSE, UINT *pIndicators = NULL, UINT nIndicators = 0, UINT uiMenu = 0,UINT uiToolBar = 0, DWORD dwToolBarStyle = TBSTYLE_FLAT | WS_CHILD | WS_VISIBLE | CBRS_TOP | CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	void AddPage( CCfgPropPage* pPage );

// Attributes
public:
	CStatusBar* GetStatusBar() { return &m_CSBCtrlStatus; }				
	CToolBar*   GetToolBar()   { return &m_CSToolBar; }

protected:
	CDlgStatusBar	m_CSBCtrlStatus;
	CDlgToolBar		m_CSToolBar;
	UINT			m_nIDTracking;
	UINT			m_nIDLastMessage;
	BOOL			m_bResetPrompt;

	BOOL			m_bToolTips;
	BOOL			m_bStatusBar;
	BOOL			m_bToolBar;
	BOOL			m_bMenu;

	BOOL			m_bKillItself;

	BOOL			m_bModal;
	UINT			m_Timer;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCfgPropSheet)
	public:
	virtual void OnCancel();
	//virtual void OnOK();
	//afx_msg void OnOK();
	virtual INT_PTR DoModal();

	afx_msg void OnFileTab();
	afx_msg void OnMcaTab();
	afx_msg void OnShapingTab();
	afx_msg void OnGainPzTab();
	afx_msg void OnPowerTab();
	afx_msg void OnMiscTab();
	void OnSelectTab(UINT NewActivePage, int nPage);
	void UpdateAll();
	UINT ActivePage;


	afx_msg void OnFileTab2(CCmdUI* pCmdUI);
	afx_msg void OnMcaTab2(CCmdUI* pCmdUI);
	afx_msg void OnShapingTab2(CCmdUI* pCmdUI);
	afx_msg void OnGainPzTab2(CCmdUI* pCmdUI);
	afx_msg void OnPowerTab2(CCmdUI* pCmdUI);
	afx_msg void OnMiscTab2(CCmdUI* pCmdUI);




	void GetCurrentButtonState();

	void OnTB1();
	protected:
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
public:

	// Generated message map functions
protected:
	//{{AFX_MSG(CCfgPropSheet)
	afx_msg void OnEnterIdle(UINT nWhy, CWnd* pWho);
	afx_msg LRESULT OnPopMessageString(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSetMessageString(WPARAM wParam, LPARAM lParam = 0L);
	afx_msg void OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu);
	afx_msg void OnUpdateKeyIndicator(CCmdUI* pCmdUI);
	afx_msg void OnUpdateStatusBarMenu(CCmdUI* pCmdUI);
	afx_msg void OnStatusBarCheck();
	afx_msg void OnToolBarCheck();
	afx_msg void OnUpdateToolBarMenu(CCmdUI* pCmdUI);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg LRESULT OnKickIdle(WPARAM, LPARAM lCount);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	BOOL OnToolTipText(UINT, NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()

	friend class CCfgPropPage;

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CFGPROPSHEET_H__INCLUDED_)

