#if !defined(AFX_GainPzPage_H__INCLUDED_)
#define AFX_GainPzPage_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GainPzPage.h : header file
//

#include "DppGain.h"				// dp5/px5/dp5g/mca8000d/tb5 analog gain tables
#include "CfgPropSheet.h"
#include "afxwin.h"
#include "label.h"

/////////////////////////////////////////////////////////////////////////////
// CGainPzPage dialog

class CGainPzPage : public CCfgPropPage
{
	DECLARE_DYNCREATE(CGainPzPage)

// Construction
public:
	CGainPzPage();
	~CGainPzPage();

// Dialog Data
	//{{AFX_DATA(CGainPzPage)
	//enum { IDD = IDD_GAINPZ_PAGE };
	//}}AFX_DATA

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CGainPzPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CGainPzPage)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	CToolTipCtrl m_ToolTip;								// Tooltip control

public:
	void BuildToolTips();								// Tooltip control

	//CStatic m_GainPzPageLabel;
	CLabel m_GainPzPageLabel;
	//CStatic m_GainAdvancedLabel;
	CLabel m_GainAdvancedLabel;
	//CStatic m_GainStandardLabel;
	CLabel m_GainStandardLabel;
	//CStatic m_PowerHvWarning;
	CLabel m_PowerHvWarning;

	virtual BOOL OnSetActive();
	virtual BOOL OnInitDialog();

	void InitControls();
	void ShowMCA8000D_Controls(int iShowWin);
	void CheckMCA8000D_FineGain();

	void InitDlgItem(HWND hDlg, DP5_CONFIGURATION cfg);
	void CboUpdate(int nID_dci);
	void TextUpdate(int nID_dci);

	//FW6.07.04 and later: The reset lockout interval can be set with 1uS precision
	BOOL bEnableNewRESL;	// controls viewing of RESL textbox
	afx_msg void OnCbnSelchangeOptComboResl();
	afx_msg void OnCbnSelchangeOptComboAinp();
	afx_msg void OnCbnSelchangeOptComboInof();
	afx_msg void OnCbnSelchangeOptComboPapz();
	afx_msg void OnEnChangeOptTextPapz();
	afx_msg void OnEnChangeOptTextResl();
	afx_msg void OnEnChangeOptTextInof();
	afx_msg void OnEnChangeOptTextGain();

	void CboTextVis(int nIdCbox, int nIdEdit, BOOL isText);

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	BOOL isCEditBox(int nID);
	BOOL isCComboBox(int nID);

	afx_msg void OnCbnSelchangeOptComboGaia();
	afx_msg void OnEnChangeOptTextGaif();

	void UpdateGainValue();
	double dblGAIF_Max;
	double dblGAIF_Min;

	afx_msg void OnBnClickedButtonFineGainEnter();
	afx_msg void OnCbnSelchangeOptComboGainSelect();
	afx_msg void OnBnClickedButtonCoarseFineToTotal();
	afx_msg void OnBnClickedButtonTotalToCoarseFine();
	afx_msg void OnCbnSelchangeOptComboGaia2();
	void UpdateOptComboGAIA();
	void SetDetResetValues(int nID, BOOL is80MHz);
	afx_msg void OnCbnSelchangeOptComboResl2();
	void InitCombo(HWND hDlg, DP5_CONFIGURATION cfg, int nID);
	CComboBox m_CoarseGain_GAIA_value;
	CComboBox m_CoarseGain_GAIA_index;
	CDppGain DppGain;
	void SetHvPowerWarning();
	afx_msg void OnHelp();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GainPzPage_H__INCLUDED_)
