#if !defined(AFX_MiscPage_H__INCLUDED_)
#define AFX_MiscPage_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MiscPage.h : header file
//

#include "CfgPropSheet.h"
#include "afxwin.h"
#include "label.h"
#include "scommon.h"

/////////////////////////////////////////////////////////////////////////////
// CMiscPage dialog

class CMiscPage : public CCfgPropPage
{
	DECLARE_DYNCREATE(CMiscPage)

// Construction
public:
	CMiscPage();
	~CMiscPage();

// Dialog Data
	//{{AFX_DATA(CMiscPage)
	//enum { IDD = IDD_MISC_PAGE };
	//}}AFX_DATA

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CMiscPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CMiscPage)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	CToolTipCtrl m_ToolTip;								// Tooltip control

public:
	void BuildToolTips();								// Tooltip control

	//CStatic m_MiscPageLabel;
	CLabel m_MiscPageLabel;
	//CStatic m_MiscAdvancedLabel;
	CLabel m_MiscAdvancedLabel;
	//CStatic m_MiscQuicksetLabel;
	CLabel m_MiscQuicksetLabel;
	
	virtual BOOL OnSetActive();
	afx_msg LONG CMiscPage::OnSetPageFocus(UINT wParam, LONG lParam);
	virtual BOOL OnInitDialog();
	afx_msg void OnCbnSelchangeOptComboDaco();

	void SetAuxList(int nAuxID, BOOL bNeedsNewAux);
	void InitAuxControls();
	void InitControls();
	void InitDlgItem(HWND hDlg, DP5_CONFIGURATION cfg);
	void ShowMCA8000D_Controls(int iShowWin);

	void CboUpdate(int nID_dci);
	void TextUpdate(int nID_dci);

	afx_msg void OnCbnSelchangeOptComboScoe();
	afx_msg void OnCbnSelchangeOptComboAuo1();
	afx_msg void OnCbnSelchangeOptComboScot();
	afx_msg void OnCbnSelchangeOptComboGped();
	afx_msg void OnCbnSelchangeOptComboGpin();
	afx_msg void OnCbnSelchangeOptComboTpmo();
	afx_msg void OnCbnSelchangeOptComboGpme();
	afx_msg void OnCbnSelchangeOptComboGpga();
	afx_msg void OnCbnSelchangeOptComboGpmc();

	afx_msg void OnEnChangeOptTextDacf();
	afx_msg void OnEnChangeOptTextDaco();
	afx_msg void OnEnChangeOptTextAuo1();
	afx_msg void OnEnChangeOptTextGpin();

	void CboTextVis(int nIdCbox, int nIdEdit, BOOL isText);

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	BOOL isCEditBox(int nID);
	BOOL isCComboBox(int nID);
	afx_msg void OnEnChangeOptTextAuo2();
	afx_msg void OnCbnSelchangeOptComboScog();
	afx_msg void OnCbnSelchangeOptComboAuo2();
	afx_msg void OnCbnSelchangeOptComboVolu();
	afx_msg void OnCbnSelchangeOptComboCon1();
	afx_msg void OnCbnSelchangeOptComboCon2();
	afx_msg void OnBnClickedButtonOutputQuickset1();
	afx_msg void OnBnClickedButtonOutputQuickset2();
	afx_msg void OnBnClickedButtonOutputQuickset3();
	void SetCboItem(int nID, CString strVal);
	void OutputQuickset(CString strDAC, CString strOutputOffset, CString strAUX2, CString strAUX1, CString strCONN1, CString strCONN2);

	// SCA Editor
	afx_msg void OnBnClickedCheckEnableSca();
	afx_msg void OnCbnSelchangeComboScaIndex();
	afx_msg void OnEnChangeEditLowThreshold();
	afx_msg void OnEnChangeEditHighThreshold();
	afx_msg void OnCbnSelchangeComboOutputLevel();
	afx_msg void OnBnClickedButtonScaDefaults();
	afx_msg void OnCbnSelchangeComboScaPulseWidth();
	afx_msg void OnBnClickedButtonPreviewSca();

	// SCA Editor Support
	BOOL GetCheckBOOL(int nID);
	void SetCheckBOOL(int nID, BOOL isChecked);
	void EnableScaControls(BOOL Enable = TRUE, BOOL isVisible = TRUE);
	void EnableControl(int nID, BOOL Enable = TRUE, BOOL isVisible = TRUE);
	void UpdateSCAControls();
	void SetSCAComboIndex(int nID, CString strValue);
	int GetComboIndex(int nID);
	CString GetComboValue(int nID);

	afx_msg void OnHelp();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MiscPage_H__INCLUDED_)
